createHud()
{
    //Main Background
    if(self getMenuVar("menu_bg_style")=="ingame")
    {
        self.Hud["Main_BG"] = createShaderBasic("fullscreen","fullscreen",0,0,640,480,"white",(0,0,0),0);
        self.Hud["Main_BG"].fadeToAlpha = 0.4;
    }
    else if(self getMenuVar("menu_bg_style")=="main_menu")
    {
        self.Hud["Main_BG"] = createShaderBasic("fullscreen","fullscreen",0,0,640,480,"mw2_main_background",(1,1,1),0);
        self.Hud["Main_BG"].fadeToAlpha = 1;
        
        //Main Background Black
        self.Hud["Main_Black"] = createShaderBasic("fullscreen","fullscreen",0,0,640,480,"white",(0,0,0),0);
        self.Hud["Main_Black"].fadeToAlpha = 1;
        
        //MP Image
        self.Hud["Main_Image"] = createShaderBasic("fullscreen","fullscreen",0,0,640,480,"mw2_main_mp_image",(1,1,1),0);
        self.Hud["Main_Image"].fadeToAlpha = 1;
    }
        
    //Side Background
    self.Hud["Side_BG"] = createRectangle("CENTER","CENTER",-447,0,600,1000,(0,0,0),0,"gradient_fadein_fadebottom");
    if(self getMenuVar("menu_bg_style")=="none")
    {
        self.Hud["Side_BG"].fadeToAlpha = (1/1.75);
    }
    else
    {
        self.Hud["Side_BG"].fadeToAlpha = 0.25;
    }
    
    //Title Text
    self.Hud["Title_Text"] = createText("hudBig",1.0,"RIGHT","TOP",self.Hud["Side_BG"].x+298,12,(1,1,1),0,(1,0,0),0,self.Menu[self getCurrentMenu()].title);
    self.Hud["Title_Text"].fadeToAlpha = 1;
        
    //Scrollbar
    self.Hud["Scrollbar"] = createRectangle("CENTER","TOP",-700,39,360,20,(0,0,0),1,"menu_button_selection_bar");//x self.Hud["Side_BG"].x+180
        
    //Glow
    if(self getMenuVar("menu_bg_style")!="none")
    {
        self.Hud["Corner_Glow_1"] = createShaderBasic("fullscreen","fullscreen",0,0,640,480,"mockup_bg_glow",(1,1,1),0);
        self.Hud["Corner_Glow_1"].fadeToAlpha = randomFloatRange(0.3,1);
    }
    
    //Sorting
    self.Hud["Main_BG"] elemSetSort(1);
    self.Hud["Side_BG"] elemSetSort(3);
    self.Hud["Title_Text"] elemSetSort(5);
    self.Hud["Scrollbar"] elemSetSort(5);
    if(self getMenuVar("menu_bg_style")!="none")
    {
        self.Hud["Corner_Glow_1"] elemSetSort(4);
    }
    if(self getMenuVar("menu_bg_style")=="main_menu")
    {
        self.Hud["Main_Black"] elemSetSort(0);
        self.Hud["Main_Image"] elemSetSort(2);
    }
    
    
    
    time = .4;
    self fadeMenuElem(self.Hud["Main_BG"],time);
    self fadeMenuElem(self.Hud["Main_Black"],time);
    self fadeMenuElem(self.Hud["Main_Image"],time);
    self fadeMenuElem(self.Hud["Side_BG"],time);
    self fadeMenuElem(self.Hud["Title_Text"],time);
    self fadeMenuElem(self.Hud["Corner_Glow_1"],time);
    wait time + .1;
    if(self getMenuVar("menu_bg_style")!="none")
    {
        self.Hud["Corner_Glow_1"] thread elemGlow(2);
    }
}

destroyHud()
{
    time = .4;
    self fadeMenuElem(self.Hud["Main_BG"],time,0);
    self fadeMenuElem(self.Hud["Main_Black"],time,0);
    self fadeMenuElem(self.Hud["Main_Image"],time,0);
    self fadeMenuElem(self.Hud["Side_BG"],time,0);
    self fadeMenuElem(self.Hud["Title_Text"],time,0);
    self.Hud["Corner_Glow_1"] notify("end_glow");
    self fadeMenuElem(self.Hud["Corner_Glow_1"],time,0);
    wait time + .1;
    
    self.Hud["Main_BG"] destroy();
    self.Hud["Side_BG"] destroy();
    self.Hud["Title_Text"] destroy();
    self.Hud["Scrollbar"] destroy();
    if(self getMenuVar("menu_bg_style")!="none")
    {
        self.Hud["Corner_Glow_1"] destroy();
    }
    if(self getMenuVar("menu_bg_style")=="main_menu")
    {
        self.Hud["Main_Black"] destroy();
        self.Hud["Main_Image"] destroy();
    }
}

createMenuElems()
{
    self updateMenuTitle();
    self.Hud["Text"] = [];
    self.Hud["Lines"] = [];
    self.Hud["Locks"] = [];
    for(i=0;i<self getMenuSize();i++)
    {
        
        //Menu Text
        self.Hud["Text"][i] = createText("default",1.5,"RIGHT","TOP",-700,38 + (20 * i),(1,1,1),0,(0,0,0),0,self.Menu[self getCurrentMenu()].text[i]);
        if(self hasMinVerifycationLevel(i))
        {
            self.Hud["Text"][i].alpha = 1;
        }
        else
        {
            self.Hud["Text"][i].alpha = 0.5;
        }
        self.Hud["Text"][i] elemSetSort(6);
        
        
        //Menu Lines
        if(isDefined(self.Menu[self getCurrentMenu()].line[i]))
        {
            if(self.Menu[self getCurrentMenu()].line[i])
            {
                index = i;
            }
            else
            {
                index = i + 1;
            }
            self.Hud["Lines"][i] = createRectangle("CENTER","TOP",-700,30 + (20 * index),250,1,(1,1,1),1,"gradient_fadein");
            self.Hud["Lines"][i] elemSetSort(6);
        }
        
        
        //Toggle Locks
        if(isDefined(self.Menu[self getCurrentMenu()].toggle[i]))
        {
            if(!self.Menu[self getCurrentMenu()].toggle[i])
            {
                color = (1,0,0);
            }
            else
            {
                color = (0,1,0);
            }
            self.Hud["Locks"][i] = createRectangle("CENTER","TOP",-700,39 + (20 * i),20,20,color,1,"ui_host");
            self.Hud["Locks"][i] elemSetSort(6);
        }
    }
    
    
    //Prestige Menu Icon
    if(self getCurrentMenuType()=="picture_prestige")
    {
        if(self getMenuScroller()>0 && self getMenuScroller()<11)
        {
            prestige_shader = getPrestigeShader(self getMenuScroller());
        }
        else if(self getMenuScroller()>10)
        {
            prestige_shader = "rank_prestige11";
        }
        else
        {
            prestige_shader = getRankShader(self.pers["rank"]);
        }
        self.Hud["pic_prestige"] = createRectangle("CENTER","TOP",700,0,18,18,undefined,1,prestige_shader);
        self.Hud["pic_prestige"] elemSetSort(6);
    }
    
    
    //Weapon Selector
    if(self getCurrentMenuType()=="weapon_selector" && self getMenuVar("weapon_selector_destroy_hud_on_menu_load"))
    {
        if(self getMenuVar("menu_bg_style")=="none")
        {
            bg_alpha = (1/1.75);
        }
        else
        {
            bg_alpha = 0.25;
        }
        self.Hud["weapon_bg"] = createRectangle("CENTER","CENTER",700,-3,230,90,(0,0,0),bg_alpha,"white");
        self.Hud["weapon_bg"] elemSetSort(3);
        
        self.Hud["weapon_pic"] = createRectangle("CENTER","CENTER",700,0,180,100,undefined,1,getWeaponShader(self.Menu[self getCurrentMenu()].input1[self getMenuScroller()]));
        self.Hud["weapon_pic"] elemSetSort(4);
        
        self.Hud["weapon_attachment_pic"] = createRectangle("CENTER","CENTER",700,22,40,40,undefined,1,getAttachmentShader(self getMenuVar("weapon_selector_confirmed_attachment")));
        self.Hud["weapon_attachment_pic"] elemSetSort(4);
        
        self.Hud["weapon_title_bg"] = createRectangle("CENTER","CENTER",700,-58,230,20,(0,0,0),bg_alpha,"white");
        self.Hud["weapon_title_bg"] elemSetSort(3);
        
        self.Hud["weapon_title"] = createText("hudBig",1.0,"CENTER","CENTER",700,-58,(1,1,1),1,(0,0,0),0,"Selected Weapon:");
        self.Hud["weapon_title"] elemSetSort(4);
    }
    
    
    
    time = .2;
    self.Hud["Scrollbar"].y = 39+(self getMenuScroller()*20);
    self.Hud["Scrollbar"] elemMoveOverTimeX(time,self.Hud["Side_BG"].x+180);
    self moveMenuTextX(time,self.Hud["Side_BG"].x+298);
    self moveMenuLinesX(time,self.Hud["Side_BG"].x+175);
    self moveToggleLocksX(time,self.Hud["Side_BG"].x+310);
    self moveMenuPrestigePictureHudX(time,self.Hud["Side_BG"].x+342,true);
    if(self getMenuVar("weapon_selector_destroy_hud_on_menu_load"))
    {
        self moveMenuWeaponSelectorHudX(time,0);
    }
    self setMenuVar("weapon_selector_destroy_hud_on_menu_load",true);
    wait time;
}
destroyMenuElems()
{
    time = .2;
    self.Hud["Scrollbar"] elemMoveOverTimeX(time,-700);
    self moveMenuTextX(time,-700);
    self moveMenuLinesX(time,-700);
    self moveToggleLocksX(time,-700);
    self moveMenuPrestigePictureHudX(time,700);
    if(self getMenuVar("weapon_selector_destroy_hud_on_menu_load"))
    {
        self moveMenuWeaponSelectorHudX(time,700);
    }
    wait time;
    self destroyMenuText();
    self destroyMenuLines();
    self destroyToggleLocks();
    self destroyMenuPrestigePictureHud();
    if(self getMenuVar("weapon_selector_destroy_hud_on_menu_load"))
    {
        self destroyMenuWeaponSelectorHud();
    }
}



updateMenuTitle()
{
    self.Hud["Title_Text"] _setText(self.Menu[self getCurrentMenu()].title);
}
updateMenuText()
{
    for(i=0;i<self getMenuSize();i++)
    {
        if(isDefined(self.Hud["Text"][i]))
        {
            self.Hud["Text"][i] _setText(self.Menu[self getCurrentMenu()].text[i]);
        }
    }
}


destroyMenuText()
{
    if(isDefined(self.Hud["Text"]))
    {
        text_elem_array = getArrayKeys(self.Hud["Text"]);
        for(i=0;i<text_elem_array.size;i++)
        {
            self.Hud["Text"][text_elem_array[i]] destroy();
        }
    }
}
moveMenuTextX(time,x)
{
    if(isDefined(self.Hud["Text"]))
    {
        text_elem_array = getArrayKeys(self.Hud["Text"]);
        for(i=0;i<text_elem_array.size;i++)
        {
            self.Hud["Text"][text_elem_array[i]] elemMoveOverTimeX(time,x);
        }
    }
}


destroyMenuLines()
{
    if(isDefined(self.Hud["Lines"]))
    {
        line_elem_array = getArrayKeys(self.Hud["Lines"]);
        for(i=0;i<line_elem_array.size;i++)
        {
            self.Hud["Lines"][line_elem_array[i]] destroy();
        }
    }
}
moveMenuLinesX(time,x)
{
    if(isDefined(self.Hud["Lines"]))
    {
        line_elem_array = getArrayKeys(self.Hud["Lines"]);
        for(i=0;i<line_elem_array.size;i++)
        {
            self.Hud["Lines"][line_elem_array[i]] elemMoveOverTimeX(time,x);
        }
    }
}

destroyToggleLocks()
{
    if(isDefined(self.Hud["Locks"]))
    {
        lock_elem_array = getArrayKeys(self.Hud["Locks"]);
        for(i=0;i<lock_elem_array.size;i++)
        {
            self.Hud["Locks"][lock_elem_array[i]] destroy();
        }
    }
}
moveToggleLocksX(time,x)
{
    if(isDefined(self.Hud["Locks"]))
    {
        lock_elem_array = getArrayKeys(self.Hud["Locks"]);
        for(i=0;i<lock_elem_array.size;i++)
        {
            self.Hud["Locks"][lock_elem_array[i]] elemMoveOverTimeX(time,x);
        }
    }
}



destroyMenuPrestigePictureHud()
{
    if(isDefined(self.Hud["pic_prestige"]))
    {
        self.Hud["pic_prestige"] destroy();
    }
}
moveMenuPrestigePictureHudX(time,x,moveIn = false)
{
    if(isDefined(self.Hud["pic_prestige"]))
    {
        if(moveIn)
        {
            self.Hud["pic_prestige"].y = 39+(self getMenuScroller()*20);
        }
        self.Hud["pic_prestige"] elemMoveOverTimeX(time,x);
    }
}
scrollUpdate_MenuPrestigePicture()
{
    self notify("prestige_scroll");
    self endon("prestige_scroll");
    if(self getCurrentMenuType()=="picture_prestige")
    {
        if(isDefined(self.Hud["pic_prestige"]))
        {
            self.Hud["pic_prestige"] elemFadeOverTime(0.170,0);
            wait 0.170;
            self.Hud["pic_prestige"].y = 39+(self getMenuScroller()*20);
            if(self getMenuScroller()>0 && self getMenuScroller()<11)
            {
                self.Hud["pic_prestige"] setShader(getPrestigeShader(self getMenuScroller()),18,18);
            }
            else if(self getMenuScroller()>10)
            {
                self.Hud["pic_prestige"] setShader("rank_prestige11",18,18);
            }
            else
            {
                self.Hud["pic_prestige"] setShader(getRankShader(self.pers["rank"]),18,18);
            }
            self.Hud["pic_prestige"] elemFadeOverTime(0.170,1);
        }
    }
}

destroyMenuWeaponSelectorHud()
{
    if(isDefined(self.Hud["weapon_bg"]))
    {
        self.Hud["weapon_bg"] destroy();
    }
    if(isDefined(self.Hud["weapon_pic"]))
    {
        self.Hud["weapon_pic"] destroy();
    }
    if(isDefined(self.Hud["weapon_attachment_pic"]))
    {
        self.Hud["weapon_attachment_pic"] destroy();
    }
    if(isDefined(self.Hud["weapon_title_bg"]))
    {
        self.Hud["weapon_title_bg"] destroy();
    }
    if(isDefined(self.Hud["weapon_title"]))
    {
        self.Hud["weapon_title"] destroy();
    }
}
moveMenuWeaponSelectorHudX(time,x)
{
    if(isDefined(self.Hud["weapon_bg"]))
    {
        self.Hud["weapon_bg"] elemMoveOverTimeX(time,x + 100);
    }
    if(isDefined(self.Hud["weapon_pic"]))
    {
        self.Hud["weapon_pic"] elemMoveOverTimeX(time,x + 120);
    }
    if(isDefined(self.Hud["weapon_attachment_pic"]))
    {
        self.Hud["weapon_attachment_pic"] elemMoveOverTimeX(time,x + 10);
    }
    if(isDefined(self.Hud["weapon_title_bg"]))
    {
        self.Hud["weapon_title_bg"] elemMoveOverTimeX(time,x + 100);
    }
    if(isDefined(self.Hud["weapon_title"]))
    {
        self.Hud["weapon_title"] elemMoveOverTimeX(time,x + 100);
    }
}
scrollUpdate_MenuWeaponSelector()
{
    self notify("weapon_scroll");
    self endon("weapon_scroll");
    if(self getCurrentMenuType()=="weapon_selector")
    {
        if(self getCurrentMenu()=="weapon_selector_attachments")
        {
            if(isDefined(self.Hud["weapon_attachment_pic"]))
            {
                self.Hud["weapon_attachment_pic"] elemFadeOverTime(0.170,0);
                wait 0.170;
                self.Hud["weapon_attachment_pic"] setShader(getAttachmentShader(self.Menu[self getCurrentMenu()].input1[self getMenuScroller()]),40,40);
                self.Hud["weapon_attachment_pic"] elemFadeOverTime(0.170,1);
            }
        }
        else if(self getCurrentMenu()=="weapon_selector_camos")
        {
            if(isDefined(self.Hud["weapon_bg"]))
            {
                self.Hud["weapon_bg"] elemFadeOverTime(0.170,0);
                wait 0.170;
                if(self.Menu[self getCurrentMenu()].input1[self getMenuScroller()]=="none")
                {
                    if(self getMenuVar("menu_bg_style")=="none")
                    {
                        bg_alpha = (1/1.75);
                    }
                    else
                    {
                        bg_alpha = 0.25;
                    }
                    shader = "white";
                    self.Hud["weapon_bg"].color = (0,0,0);
                }
                else
                {
                    bg_alpha = 1;
                    shader   = getCamoShader(self.Menu[self getCurrentMenu()].input1[self getMenuScroller()]);
                    self.Hud["weapon_bg"].color = (1,1,1);
                }
                self.Hud["weapon_bg"] setShader(shader,230,90);
                self.Hud["weapon_bg"] elemFadeOverTime(0.170,bg_alpha);
            }
        }
        else
        {
            if(isDefined(self.Hud["weapon_pic"]))
            {
                self.Hud["weapon_pic"] elemFadeOverTime(0.170,0);
                wait 0.170;
                self.Hud["weapon_pic"] setShader(getWeaponShader(self.Menu[self getCurrentMenu()].input1[self getMenuScroller()]),180,100);
                self.Hud["weapon_pic"] elemFadeOverTime(0.170,1);
            }
        }
    }
}


fadeMenuElem(elem,fade_time,alpha)
{
    if(isDefined(elem))
    {
        if(!isDefined(alpha) && isDefined(elem.fadeToAlpha))
        {
            alpha = elem.fadeToAlpha;
        }
        else
        {
            alpha = 0;
        }
        elem elemFadeOverTime(fade_time,alpha);
    }
}