_setUpMenu()
{
    self.PIX        = [];
    self.Menu       = [];
    self.Hud        = [];
    self.Scroller   = [];
    self.hasMenu    = false;
    self.TestToggle = false;
    
    //Menu Common
    self setMenuVar("menu_controls","menu");//menu,ays
    self setMenuVar("menu_bg_style","ingame");//ingame,main_menu,none
    self setMenuVar("menu_sounds",true);
    self setMenuVar("menu_freeze",true);
    
    //Menu Weapon Selector
    self setMenuVar("weapon_selector_destroy_hud_on_menu_load",true);
    self setMenuVar("weapon_selector_confirmed_weapon","none");
    self setMenuVar("weapon_selector_confirmed_attachment","none");
    self setMenuVar("weapon_selector_confirmed_camo","none");
    
    //Menu AYS(Are You Sure)
    self setMenuVar("ays_selected","Yes");
    self setMenuVar("ays_selected_func",undefined);
    self setMenuVar("ays_selected_input1",undefined);
    self setMenuVar("ays_selected_input2",undefined);
    self setMenuVar("ays_selected_input3",undefined);
}



player_menu_func_spawn_check()
{
    if(self.isFirstSpawn)
    {
        self.GodMode       = false;
        self.UnlimitedAmmo = false;
        self.Clone_Follow  = false;
    }
    else
    {
        if(self.hasMenu && self getMenuVar("opened"))
        {
            self setMenuHudDvars(self getMenuVar("opened"));
        }
        if(self.Clone_Follow)
        {
            self.Clone_Follow = false;
        }
    }
}









giveMenu()
{
    if(!self.hasMenu)
    {
        self thread initMenu();
        self.hasMenu = true;
    }
}
removeMenu()
{
    if(self.hasMenu)
    {
        if(self getMenuVar("opened"))
        {
            self _closeMenu();
            wait .2;
        }
        self notify("Remove_Menu");
        self.hasMenu = false;
    }
}


initMenu()
{
    self setMenuVar("menu_controls","menu");
    self setMenuVar("opened",false);
    self setMenuVar("locked",false);
    self.PIX["CurrentMenu"] = undefined;
    self thread menuMain();
}
menuMain()
{
    self endon("disconnect");
    self endon("Remove_Menu");
    for(;;)
    {
        if(!self getMenuVar("opened") && !self getMenuVar("locked"))
        {
            if(self MeleeButtonPressed() && self AdsButtonPressed())
            {
                self _openMenu();
                wait .4;
            }
        }
        else if(self getMenuVar("opened") && !self getMenuVar("locked"))
        {
            if(self getMenuVar("menu_freeze"))
            {
                self freezeControls(true);
            }
            if(self getMenuVar("menu_controls")=="menu")
            {
                self _menuControls();
            }
            else if(self getMenuVar("menu_controls")=="ays")
            {
                self _aysControls();
            }
            else
            {
                self iprintln("^1UNKOWN menu_controls!!!");
                self _closeMenu();
                self setMenuVar("menu_controls","menu");
            }
        }
        wait 0.05;
    }
}


_menuControls()
{
    if(self AttackButtonPressed()||self AdsButtonPressed())
    {
        if(self getMenuVar("menu_sounds"))
        {
            self playLocalSound("mouse_over");
        }
        scroll_value = self getMenuScroller();
        scroll_value -= self AdsButtonPressed();
        scroll_value += self AttackButtonPressed();
        self setMenuScroller(scroll_value);
        self _scrollMenu();
        wait 0.170;
    }
    if(self UseButtonPressed())
    {
        if(self getMenuVar("menu_sounds"))
        {
            self playLocalSound("mouse_click");
        }
        if(!self.Menu[self getCurrentMenu()].menuLoader[self getMenuScroller()])
        {
            if(self hasMinVerifycationLevel(self getMenuScroller(),true))
            {
                func   = self.Menu[self getCurrentMenu()].func[self getMenuScroller()];
                input1 = self.Menu[self getCurrentMenu()].input1[self getMenuScroller()];
                input2 = self.Menu[self getCurrentMenu()].input2[self getMenuScroller()];
                input3 = self.Menu[self getCurrentMenu()].input3[self getMenuScroller()];
                if(self.Menu[self getCurrentMenu()].AYS[self getMenuScroller()])
                {
                    self startAYS(self.Menu[self getCurrentMenu()].ays_info[self getMenuScroller()],func,input1,input2,input3);
                }
                else
                {
                    self thread [[func]](input1,input2,input3);
                }
                if(isDefined(self.Menu[self getCurrentMenu()].toggle[self getMenuScroller()]))
                {
                    self _selectUpdate();
                }
            }
        }
        else
        {
            if(self hasMinVerifycationLevel(self getMenuScroller(),true))
            {
                self _loadMenu(self.Menu[self getCurrentMenu()].input1[self getMenuScroller()]);
            }
        }
        wait .4;
    }
    if(self MeleeButtonPressed())
    {
        if(self getMenuVar("menu_sounds"))
        {
            self playLocalSound("mouse_click");
        }
        if(self.Menu[self getCurrentMenu()].parent=="Exit")
        {
            self _closeMenu();
        }
        else
        {
            self _loadMenu(self.Menu[self getCurrentMenu()].parent);
        }
        wait .4;
    }
}


_aysControls()
{
    if(self AttackButtonPressed()||self AdsButtonPressed())
    {
        if(self getMenuVar("menu_sounds"))
        {
            self playLocalSound("mouse_over");
        }
        if(self AttackButtonPressed())
        {
            if(self getMenuVar("ays_selected")!="No")
            {
                self setMenuVar("ays_selected","No");
            }
            else
            {
                self setMenuVar("ays_selected","Yes");
            }
        }
        if(self AdsButtonPressed())
        {
            if(self getMenuVar("ays_selected")!="Yes")
            {
                self setMenuVar("ays_selected","Yes");
            }
            else
            {
                self setMenuVar("ays_selected","No");
            }
        }
        self scrollAYS();
        wait 0.170;
    }
    if(self UseButtonPressed())
    {
        if(self getMenuVar("menu_sounds"))
        {
            self playLocalSound("mouse_click");
        }
        if(self getMenuVar("ays_selected")=="Yes")
        {
            if(isDefined(self getMenuVar("ays_selected_func")))
            {
                self thread [[self getMenuVar("ays_selected_func")]](self getMenuVar("ays_selected_input1"),self getMenuVar("ays_selected_input2"),self getMenuVar("ays_selected_input3"));
            }
        }
        self endAYS();
        wait .4;
    }
    if(self MeleeButtonPressed())
    {
        if(self getMenuVar("menu_sounds"))
        {
            self playLocalSound("mouse_click");
        }
        self endAYS();
        wait .4;
    }
}





_openMenu()
{
    if(self getMenuVar("menu_sounds"))
    {
        self playLocalSound("ui_mp_suitcasebomb_timer");
    }
    self setMenuVar("opened",true);
    self setMenuHudDvars(self getMenuVar("opened"));
    self createHud();
    self _loadMenu(self getCurrentMenu());
}
_closeMenu()
{   
    if(self getMenuVar("menu_controls")=="ays")
    {
        self endAYS();
    }
    self destroyMenuElems();
    self destroyHud();
    self setMenuVar("opened",false);
    self freezeControls(false);
    self setMenuHudDvars(self getMenuVar("opened"));
}


_loadMenu(menu = "main")
{
    if(menu=="weapon_selector_menu")
    {
        self setMenuVar("weapon_selector_confirmed_weapon","none");
        self setMenuVar("weapon_selector_confirmed_attachment","none");
        self setMenuVar("weapon_selector_confirmed_camo","none");
        //self iprintln("^1WS Reset LOL!!!");
    }
    self destroyMenuElems();
    self _loadMenuStructure();
    self setCurrentMenu(menu);
    self createMenuElems();
    self _scrollMenu();
}
_selectUpdate()
{
    self _loadMenuStructure();
    for(i=0;i<self getMenuSize();i++)
    {
        if(isDefined(self.Menu[self getCurrentMenu()].toggle[i]))
        {
            if(!self.Menu[self getCurrentMenu()].toggle[i])
            {
                color = (1,0,0);
            }
            else
            {
                color = (0,1,0);
            }
            self.Hud["Locks"][i].color = color;
        }
    }
}
_scrollMenu()
{
    self.Hud["Scrollbar"] elemMoveOverTimeY(0.170,39+(self getMenuScroller()*20));
    self thread scrollUpdate_MenuPrestigePicture();
    self thread scrollUpdate_MenuWeaponSelector();
    for(i=0;i<self getMenuSize();i++)
    {
        if(i==self getMenuScroller())
        {
            if(self hasMinVerifycationLevel(i))
            {
                self.Hud["Text"][i] thread elemBlink();
                if(isDefined(self.Menu[self getCurrentMenu()].toggle[i]))
                {
                    self.Hud["Locks"][i] thread elemBlink();
                }
            }
        }
        else
        {
            self.Hud["Text"][i] notify("Update_Blink");
            if(self hasMinVerifycationLevel(i))
            {
                self.Hud["Text"][i].alpha = 1;
            }
            else
            {
                self.Hud["Text"][i].alpha = 0.5;
            }
            if(isDefined(self.Menu[self getCurrentMenu()].toggle[i]))
            {
                self.Hud["Locks"][i] notify("Update_Blink");
                self.Hud["Locks"][i].alpha = 1;
            }
        }
    }
}