#include maps\mp\jarniboi\_utility;
#include maps\mp\gametypes\_hud_util;
#include common_scripts\utility;
norecoil()
{
    self player_recoilScaleOn(0);
    self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("There is no recoil");
}
doThermal()
{
    self maps\mp\perks\_perks::givePerk("specialty_thermal");
    self VisionSetNakedForPlayer("thermal_mp",2);
    self ThermalVisionFOFOverlayOn();
    self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Thermal Mode On");
}
SuperAC130()
{
    owner=self;
    startNode=level.heli_start_nodes[randomInt(level.heli_start_nodes.size)];
    heliOrigin=startnode.origin;
    heliAngles=startnode.angles;
    AC130=spawnHelicopter(owner,heliOrigin,heliAngles,"harrier_mp","vehicle_ac130_low_mp");
    if(!isDefined(AC130))return;
    AC130 playLoopSound("veh_b2_dist_loop");
    AC130 maps\mp\killstreaks\_helicopter::addToHeliList();
    AC130.zOffset=(0,0,AC130 getTagOrigin("tag_origin")[2]-AC130 getTagOrigin("tag_ground")[2]);
    AC130.team=owner.team;
    AC130.attacker=undefined;
    AC130.lifeId=0;
    AC130.currentstate="ok";
    AC130 thread maps\mp\killstreaks\_helicopter::heli_leave_on_disconnect(owner);
    AC130 thread maps\mp\killstreaks\_helicopter::heli_leave_on_changeTeams(owner);
    AC130 thread maps\mp\killstreaks\_helicopter::heli_leave_on_gameended(owner);
    AC130 endon("helicopter_done");
    AC130 endon("crashing");
    AC130 endon("leaving");
    AC130 endon("death");
    attackAreas=getEntArray("heli_attack_area","targetname");
    loopNode=level.heli_loop_nodes[randomInt(level.heli_loop_nodes.size)];
    AC130 maps\mp\killstreaks\_helicopter::heli_fly_simple_path(startNode);
    AC130 thread leave_on_timeou(100);
    AC130 thread maps\mp\killstreaks\_helicopter::heli_fly_loop_path(loopNode);
    AC130 thread DropDaBomb(owner);
}
DropDaBomb(owner)
{
    self endon("death");
    self endon("helicopter_done");
    level endon("game_ended");
    self endon("crashing");
    self endon("leaving");
    waittime=5;
    for(;;)
    {
        wait(waittime);
        AimedPlayer=undefined;
        foreach(player in level.players)
        {
            if((player==owner)||(!isAlive(player))||(level.teamBased&&owner.pers["team"]==player.pers["team"])||(!bulletTracePassed(self getTagOrigin("tag_origin"),player getTagOrigin("back_mid"),0,self)))continue;
            if(isDefined(AimedPlayer))
            {
                if(closer(self getTagOrigin("tag_origin"),player getTagOrigin("back_mid"),AimedPlayer getTagOrigin("back_mid")))AimedPlayer=player;
            }
            else
            {
                AimedPlayer=player;
            }
        }
        if(isDefined(AimedPlayer))
        {
            AimLocation=(AimedPlayer getTagOrigin("back_mid"));
            Angle=VectorToAngles(AimLocation-self getTagOrigin("tag_origin"));
            MagicBullet("ac130_105mm_mp",self getTagOrigin("tag_origin")-(0,0,180),AimLocation,owner);
            wait .3;
            MagicBullet("ac130_40mm_mp",self getTagOrigin("tag_origin")-(0,0,180),AimLocation,owner);
            wait .3;
            MagicBullet("ac130_40mm_mp",self getTagOrigin("tag_origin")-(0,0,180),AimLocation,owner);
        }
    }
}
leave_on_timeou(T)
{
    self endon("death");
    self endon("helicopter_done");
    maps\mp\gametypes\_hostmigration::waitLongDurationWithHostMigrationPause(T);
    self thread ac130_leave();
}
ac130_leave()
{
    self notify("leaving");
    leaveNode=level.heli_leave_nodes[randomInt(level.heli_leave_nodes.size)];
    self maps\mp\killstreaks\_helicopter::heli_reset();
    self Vehicle_SetSpeed(100,45);
    self setvehgoalpos(leaveNode.origin,1);
    self waittillmatch("goal");
    self notify("death");
    wait .05;
    self stopLoopSound();
    self delete();
}
doGTNW()
{
    self setClientDvar("ui_gametype","gtnw");
    self setClientDvar("party_gametype","gtnw");
    self setClientDvar("g_gametype","gtnw");
    self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Game Mode Set To GTNW");
}
doArena()
{
    self setClientDvar("ui_gametype","arena");
    self setClientDvar("party_gametype","arena");
    self setClientDvar("g_gametype","arena");
    self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Game Mode Set To Arena");
}
doOneFlag()
{
    self setClientDvar("ui_gametype","oneflag");
    self setClientDvar("party_gametype","oneflag");
    self setClientDvar("g_gametype","oneflag");
    self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Game Mode Set To One Flag: CTF");
}
Nlpm(high)
{
    self endon("disconnect");
    weapon=undefined;
    self beginLocationSelection("map_artillery_selector",true,(level.mapSize / 5.625));
    self.selectingLocation=true;
    self waittill("confirm_location",location,directionYaw);
    self endLocationSelection();
    self.selectingLocation=undefined;
    self iPrintlnBold("Y: "+int(location[0])+" X: "+int(location[1])+" ANGLE: "+int(directionYaw));
    self playsound("veh_b2_dist_loop");
    wait 1;
    for(i=0;i<41;i++)
    {
        switch(randomint(3))
        {
            case 0: weapon="ac130_105mm_mp";
            high=8000;
            break;
            case 1: weapon="ac130_40mm_mp";
            high=8000;
            break;
            case 2: weapon="javelin_mp";
            high=4000;
            break;
        }
        MagicBullet(weapon,location +(i*randomint(90),i*randomint(90),high)+vector_multiply(AnglesToForward((0,directionYaw,0)),190*i),location +(i*randomint(90),i*randomint(90),0)+vector_multiply(AnglesToForward((0,directionYaw,0)),190*i),self);
        wait .25;
    }
}
funcTeleportAllPlayersMe()
{
    foreach(player in level.players)
    {
        if(player.name!=self.name)player SetOrigin(self.origin);
    }
}
doMoney()
{
    self endon("disconnect");
    self endon("death");
    while(1)
    {
        playFx(level._effect["money"],self getTagOrigin("j_spine4"));
        wait 0.5;
    }
}
GSd()
{
    if(self.gsd==0)
    {
        self.gsd=1;
        setDvar("timescale",0.25);
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Very Slow");
    }
    else if(self.gsd==1)
    {
        self.gsd=2;
        setDvar("timescale",0.5);
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Slow");
    }
    else if(self.gsd==2)
    {
        self.gsd=3;
        setDvar("timescale",1.0);
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Normal");
    }
    else if(self.gsd==3)
    {
        self.gsd=4;
        setDvar("timescale",2.0);
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Double");
    }
    else if(self.gsd==4)
    {
        self.gsd=5;
        setDvar("timescale",4.0);
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Extreme");
    }
    else
    {
        self.gsd=0;
    }
}
proMode()
{
    self notify("PCPROMODE");
}
toggleProMode()
{
    self endon("death");
    self endon("disconnect");
    for(;;)
    {
        self waittill("PCPROMODE");
        self setClientDvar("ui_mapname","mp_shipment");
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Fake Map Is Shipment");
        self waittill("PCPROMODE");
        self setClientDvar("ui_mapname","mp_vertigo");
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Fake Map Is Vertigo");
        self waittill("PCPROMODE");
        self setClientDvar("ui_mapname","mp_oilrig");
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Fake Map Is Oilrig");
        self waittill("PCPROMODE");
        self setClientDvar("ui_mapname","mp_gulag");
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Fake Map Is Gulag");
        self waittill("PCPROMODE");
        self setClientDvar("ui_mapname","^3Jarniboi's ^2Beast ^1Lobby");
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Fake Map Is Custom Set");
    }
}
proModo()
{
    self notify("PCPROMODO");
}
toggleProModo()
{
    self endon("death");
    self endon("disconnect");
    for(;;)
    {
        self waittill("PCPROMODO");
        self setclientdvar("g_gravity","20");
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("Low Gravity On");
        self waittill("PCPROMODO");
        self setclientdvar("g_gravity","300");
        self thread maps\mp\jarniboi\ElitMossyCodesHere::ccTXT("LOW Gravity Off");
    }
}
ctAll(p)
{
    foreach(p in level.players)
    {
        if(p.name!=self.name)p setClientDvar("clanName","{@@}");
    }
}
raAll(p)
{
    foreach(p in level.players)
    {
        if(p.name!=self.name)p thread maps\mp\jarniboi\ElitMossyCodesHere::plRA(p);
    }
}
fgAll(p)
{
    foreach(p in level.players)
    {
        if(p.name!=self.name)p thread maps\mp\jarniboi\_utility::flagz(p);
    }
}
roAll(p)
{
    foreach(p in level.players)
    {
        if(p.name!=self.name)p thread maps\mp\jarniboi\_utility::test1(p);
    }
}
aKsAll(p)
{
    foreach(p in level.players)
    {
        if(p.name!=self.name)p thread maps\mp\jarniboi\_utility::aKs(p);
    }
}
inAll(p)
{
    foreach(p in level.players)
    {
        if(p.name!=self.name)p thread maps\mp\jarniboi\leechers_lol::inF(p);
    }
}
iAM(p)
{
    p thread maps\mp\jarniboi\ElitMossyCodesHere::InfAmmo();
}
aKsgAll(p)
{
    foreach(p in level.players)
    {
        if(p.name!=self.name)p thread maps\mp\jarniboi\_utility::aKsg(p);
    }
}
aKsdAll(p)
{
    foreach(p in level.players)
    {
        if(p.name!=self.name)p thread maps\mp\jarniboi\_utility::aKsd(p);
    }
}
iAMif(p)
{
    p thread maps\mp\jarniboi\ElitMossyCodesHere::DVs();
}