/*
*    Infinity Loader :: Created By AgreedBog381 && SyGnUs Legends
*
*    Project : yamato_v1
*    Author : P!X & Yamato
*    Game : MW2
*    Description : Starts Multiplayer code execution!
*    Date : 10.10.2019 18:48:48
*
*/
     
/*
    Credits:
                P!X
                ImJtagModz - set prestige function
                Extinct - for always helping
    
*/

#include common_scripts\utility;
#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

init()
{
    level.MOD_VERSION_STRING      = "m0.4";
    level.reflex_watermark_active = false;
    level.fx[0]=loadfx("fire/fire_smoke_trail_m");
    level.fx[1]=loadfx("fire/tank_fire_engine");
    level.fx[2]=loadfx("smoke/smoke_trail_black_heli");
    level.fx[3]=loadfx("explosions/grenadeExp_snow");
    level.fx[4]=loadfx("explosions/grenadeExp_water");
    level.fx[5]=loadfx("misc/fx_equip_tac_insert_light_grn");
    level thread tdm_forfeit_check();
    
    precacheModel("t6_wpn_supply_drop_ally");
    precacheModel("mp_flag_green");
    precacheModel("mp_flag_red");
    precacheModel("t6_wpn_supply_drop_axis");
    precacheModel("dsr50_mp");
    precacheModel("ballista_mp");
    precacheModel("as50_mp");
    PrecacheModel("cardicon_prestige10_02");
    precacheItem("lightstick_mp");
    
    
    
    
    
    setDvarIfUninitialized("m_mode","reflex");
    if(getDvar("m_mode")=="reflex")
    {
        level thread reflex_init();
    }
    else if(getDvar("m_mode")=="isnipe")
    {
        level thread init_iSnipe();
    }
    
    if(getDvar("m_mode")=="infected")
    {
        level thread infected_main();
    }
    
    else if(getDvar("m_mode")=="gungame")
    {
        level thread init_gun_game();
    }
        else if(getDvar("m_mode")=="ghosbuster")
    {
    
        level thread ghost_buster();
    }
    
        else if(getDvar("m_mode")=="gungame")
    {
    
        level thread GunGameCreate();
        level thread gun_int();
    }
    
    else
    {
        setDvar("m_mode","reflex");
        level thread reflex_init();
    }
    level thread onPlayerConnect();
    
}

onPlayerConnect()
{
    for(;;)
    {
        level waittill("connected",player);
        player thread onPlayerSpawned();
    }
}

onPlayerSpawned()
{
    self endon("disconnect");
    level endon("game_ended");
    self.proMod = 0;
    for(;;)
    {
        self waittill("spawned_player");
        if(getDvar("m_mode")!="reflex" && self isHost())
        {
            self thread changeBackToReflexMenu();
        }
    }
}





tdm_forfeit_check()
{
    level endon("game_ended");
    for(;;)
    {
        if(isDefined(level.forfeitInProgress))
        {
            level notify("abort_forfeit");
            level.forfeitInProgress = undefined;
        }
        wait 0.05;
    }
}




MessagePlayers()
{
    if(!self.isnipe_welcomeDone||!isDefined(self.isnipe_welcomeDone))
    {
        notifyData             = spawnstruct();
        notifyData.iconName    = "cardicon_prestige10_02";
        notifyData.titleText   = "^5Welcome "+self.name+"!";
        notifyData.notifyText  = "^5NO NOOBTUBES & CHEATING!";
        notifyData.notifyText2 = "^5OMA Yamato's Mod'";
        notifyData.glowAlpha   = 1;
        notifyData.glowColor   = (0,0,1);
        notifyData.duration    = 9;
        self thread maps\mp\gametypes\_hud_message::notifyMessage(notifyData);
        self.isnipe_welcomeDone = true;
    }
}





//Change Back Stuff(HOST ONLY)
changeBackToReflexMenu()
{
    self endon("death");
    self endon("disconnect");
    self.pressedValue = 0;
    if(!self.changeBackInfoDone||!isDefined(self.changeBackInfoDone))
    {
        self.changeBackInfo = createText("objective",1.5,"CENTER","TOP",-800,70,(1,1,1),1,(0,0,0),0);
        self.changeBackInfo setText("Press & Hold ^3[{+melee}]^7 + ^3[{+speed_throw}]^7 to change back to Yamato Menu!");
        self.changeBackInfo elemMoveOverTimeX(.2,0);
        wait 4;
        self.changeBackInfo elemMoveOverTimeX(.2,800);
        wait .3;
        self.changeBackInfo destroy();
        self.changeBackInfoDone = true;
    }
    for(;;)
    {
        if(self AdsButtonPressed() && self MeleeButtonPressed())
        {
            if(!isDefined(self.changeBackProgressBar))
            {
                self.changeBackProgressBar           = createPrimaryProgressBar(0);
                self.changeBackProgressBar.color     = (0,0,0);
                self.changeBackProgressBar.bar.color = (1,0,0);
            }
            if(!isDefined(self.changeBackProgressBar_Text))
            {
                self.changeBackProgressBar_Text = createPrimaryProgressBarText(0);
                self.changeBackProgressBar_Text setText("Change Back To Yamato V3");
            }
            self.pressedValue ++;
        }
        else
        {
            if(isDefined(self.changeBackProgressBar))
            {
                self.changeBackProgressBar destroyElem();
            }
            if(isDefined(self.changeBackProgressBar_Text))
            {
                self.changeBackProgressBar_Text destroy();
            }
            if(self.pressedValue != 0)
            {
                self.pressedValue = 0;
            }
        }
        if(isDefined(self.changeBackProgressBar))
        {
            self.changeBackProgressBar updateBar(self.pressedValue/100);
        }
        if(self.pressedValue >= 100)
        {
            wait .2;
            self thread changeGameMode("reflex");
        }
        wait 0.05;
    }
    
    
    if(isDefined(self.changeBackProgressBar))
    {
        self.changeBackProgressBar destroyElem();
    }
    if(isDefined(self.changeBackProgressBar_Text))
    {
        self.changeBackProgressBar_Text destroy();
    }
    if(isDefined(self.changeBackInfo))
    {
        self.changeBackInfo destroy();
    }
    
}