reflex_init()
{
    //Menu
    precacheShader("gradient_fadein");
    precacheShader("gradient_fadein_fadebottom");
    precacheShader("menu_button_selection_bar");
    precacheShader("mockup_bg_glow");
    precacheShader("mw2_main_background");//not working on xbox
    precacheShader("mw2_main_mp_image");//not working on xbox
    precacheShader("ui_host");
    
    
    //Prestige Selection
    precacheShader("rank_prestige11");
    
    
    //Weapon Selection
    level thread init_menu_weapons();
    
    
    //Player Animations
    precacheMpAnim("pb_stand_alert");
    precacheMpAnim("pb_walk_forward_akimbo");
    precacheMpAnim("pb_run_fast");
    precacheMpAnim("pb_sprint_akimbo");
    
    
    //Remove Map Kill Triggers
    level thread removeKillTriggers();
    
    
    level.overFlowFix_Started = false;
    level thread init_verifycation_system();
    level thread reflex_onPlayerConnect();
}

reflex_onPlayerConnect()
{
    for(;;)
    {
        level waittill("connected",player);
        player thread _setUpMenu();
        player thread player_monitor_verifycation();
        player thread reflex_onPlayerSpawned();
    }
}

reflex_onPlayerSpawned()
{
    self endon("disconnect");
    level endon("game_ended");
    self.isFirstSpawn = true;
    for(;;)
    {
        self waittill("spawned_player");
        self player_menu_func_spawn_check();
        if(!level.overFlowFix_Started && self isHost())//////////overflow fix for all (game)mods???
        {
            level thread init_overFlowFix();
        }
        if(self.isFirstSpawn)
        {
            self player_set_verifycation_on_first_spawn();
            self.isFirstSpawn = false;
        }
    }
}